# FreeKernelJS


### Contents
1. [About FreeKernelJS](#about)
2. [When Should I Use FreeKernelJS?](#use)
3. [Getting Started](#getting-started)
4. [Templates](#templates)
5. [Themes](#themes)
6. [Development Tools](#development)
7. [Contributing to This Project](#contribute)
8. [License](#license)
9. [Releases](#releases)

# <a name="about"></a> About FreeKernelJS
FreeKernelJS aims to provide developers with a set of tools to produce a Web application structured from a Template, and to use common tasks in development such as: testing the application, generate documentation, produce a distribution version, and more.

To accelerate the production of the applications FreeKernelJS uses a Generator, which also makes the entire process simple and easy to use.  
FreeKernelJS Generator creates for you a work environment - the Workspace, a separate Web project for each application, and enables you to develop custom Templates and Themes, then - import them into FreeKernelJS to be operated by its Generator.

##### FreeKernelJS is based on these technologies:
[![Yeoman](http://pixel-cookers.github.io/built-with-badges/yeoman/yeoman-short.png)](http://yeoman.io/)
[![Grunt](http://pixel-cookers.github.io/built-with-badges/grunt/grunt-short.png)](http://gruntjs.com/)
[![Bower](http://pixel-cookers.github.io/built-with-badges/bower/bower-short.png)](http://bower.io/)
[![Karma](http://pixel-cookers.github.io/built-with-badges/karma/karma-short.png)](https://karma-runner.github.io)

**Support**  
Supported platforms: Windows, iOS, Linux.  
Supported Browsers: designed to support the current versions of Chrome, Firefox, and Internet Explorer 10+.

# <a name="use"></a> When Should I Use FreeKernelJS?
- [x] You are looking to learn the basics.
- [x] You need a tool to kick start your Web project.
- [x] You want to test standard technologies and learn how to use them.
- [x] You want to generate a skeleton app that can be extended and used in large projects.
- [x] You want to produce quickly several different apps, build with different UI packages/libraries.
- [x] You need a complete modular environment, where you can develop your applications.

# <a name="getting-started"></a> Getting Started
1. **[Concept and Terminology](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/Concept-and-Terminology)**: understand the main concept behind FreeKernelJS and learn about its terminology.
2. **[Installation](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/installation)**: first, you will need to install the environment with only 4 easy steps!
3. **[Generate and Manage New Projects](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/generate-app)**: then you can learn how to generate a new Project, how to configure and manage it. 

# <a name="templates"></a> Templates
FreeKernelJS offers a collection of Templates from which you can choose.  
Each Template contains different features and UI libraries, and can be used to generate an App.  
A list of available Templates is specified on this page: **[Templates](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/templates)**.  
In addition, you can enlarge your collection of Templates by **[Creating a Custom Template](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/templates#custom)** yourself.

# <a name="themes"></a> Themes
Each App that FreeKernelJS generates can use a single Theme.  
You can use the default Theme that comes built-in with the Template you choose, or create your own custom Theme and use it in your application.  
To learn how to do that read **[Creating a Custom Theme](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/Themes#custom)**.

# <a name="development"></a> Development Tools
FreeKernelJS comes with a set of tasks, powered by Grunt, which can be used during development to perform routine operations such as: unit testing, distribution, Sass compilation, etc.  
A list of available tasks and instructions on how to use them can be found on this page: **[Use Grunt Tasks in Development](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/grunt-tasks)**

# <a name="contribute"></a> Contributing to This Project
You are welcome to contribute to this project by adding custom Templates or Themes that can be used by FreeKernelJS. For more details read:  
[Creating a Custom Template](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/templates#custom).  
[Creating a Custom Theme](https://github.com/FreeKernelJS/generator-freekerneljs/wiki/Themes#custom)  
For general questions and discussions, please refer to the [FreeKernelJS Forum](http://www.forum.freekerneljs.org/).

# <a name="license"></a> License
This project is under the [MIT License](https://github.com/FreeKernelJS/generator-freekerneljs/blob/master/LICENSE).

# <a name="releases"></a> Releases
Complete historical information about the FreeKernelJS releases, including notes and download links, can be found on the [releases page](https://github.com/FreeKernelJS/generator-freekerneljs/releases).
